-- Tech Diffusion
-- Author: Afforess
-- DateCreated: 10/8/2010 8:52:20 PM
--------------------------------------------------------------
include ( "CCMATconfig" );

iTechsBehindReq = 6;
iTechsBehindFullBenefit = 12;

function TechDiffusion()
	for iPlayerLoop = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
		local pPlayer = Players[ iPlayerLoop ];
		if pPlayer ~= nil and pPlayer:IsAlive() then
			local pTeam = Teams[pPlayer:GetTeam()];
			local pTeamTechs = pTeam:GetTeamTechs();

			local iTechsBehindLead = numberOfTechsBehindLeadTeam(pTeam);
			print(string.format("Techs Behind Lead Team: %d", iTechsBehindLead));

			if (iTechsBehindReq < iTechsBehindLead) then

				for eTech in GameInfo.Technologies() do
					if not pTeam:IsHasTech(eTech.ID) then

						local knownExp = 0;
						for iTeamLoop = 0, GameDefines.MAX_CIV_TEAMS-1, 1 do
							pOtherTeam = Teams[iTeamLoop];
							if(pOtherTeam ~= nil) and pOtherTeam:GetID() ~= pTeam:GetID() then
								if pOtherTeam:IsHasTech(eTech.ID) and pTeam:IsHasMet(pOtherTeam:GetID()) then
									local teamExp = 0.5;
									if (pTeam:GetCurrentEra() < pOtherTeam:GetCurrentEra()) then
										teamExp = teamExp + (pOtherTeam:GetCurrentEra() - pTeam:GetCurrentEra() / 2);
									end
									if pTeam:IsAtWar(pOtherTeam:GetID()) then
										teamExp = teamExp + 0.5;
									end
									if pTeam:IsAllowsOpenBordersToTeam(pOtherTeam:GetID()) then
										teamExp = teamExp + 0.5;
									end
									if (pPlayer:IsWorkingWithPlayer(pOtherTeam:GetLeaderID())) then
										teamExp = teamExp + 0.5;
									end
									knownExp = knownExp + teamExp;
								end
							end
						end
						print(string.format("Tech Numerator for %s: %d", eTech.Type, knownExp));

						local iModifier = 100;
						local techDiffMod = 50;
						if (knownExp > 0.0) then
							iModifier = iModifier + (techDiffMod - math.floor((techDiffMod * math.pow(0.85, knownExp) + 0.5)));
						end

						-- Tech flows downhill to those who are far behind
						local iTechScorePercent = getBestKnownTechScorePercent(pTeam);
						local iWelfareThreshold = 75;
						local iWelfareModifier = 50;
						if( iTechScorePercent < iWelfareThreshold ) then
							if( knownExp > 0.0 ) then
								iModifier = iModifier + (iWelfareModifier * Game:GetCurrentEra() * (iWelfareThreshold - iTechScorePercent))/200;
							end
						end

						--Teams don't recieve full effect unless very far behind
						if (iModifier > 100) then
							iModifier = iModifier * math.pow(iTechsBehindLead / iTechsBehindFullBenefit, 0.45);
						end

						print(string.format("Tech Modifier for %s: %d", eTech.Type, iModifier));

						if (iModifier > 100) then
							local iTechCost = pTeamTechs:GetResearchCost(eTech.ID);
							local iFreeBeakers = ((iTechCost * iModifier) / 100) - iTechCost;
							iFreeBeakers = math.pow(iFreeBeakers,0.40);
							iFreeBeakers = math.floor(iFreeBeakers * 100);

							print(string.format("Free Beakers for Tech for %s: %d", eTech.Type, (iFreeBeakers / 100)));

							pTeamTechs:ChangeResearchProgressTimes100(eTech.ID, iFreeBeakers);
						end
					end
				end
			end
		end
	end
end

function getBestKnownTechScorePercent(pTeam)
	local iOurTechScore = 0;
	local iBestKnownTechScore = 0;

	for iPlayerLoop = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
		local pPlayer = Players[ iPlayerLoop ];
		if pPlayer ~= nil and pPlayer:IsAlive() then
			if Teams[pPlayer:GetTeam()]:GetID() == pTeam:GetID() then
				iOurTechScore = math.max( iOurTechScore, pPlayer:GetTechScore() );
			elseif (pTeam:IsHasMet(pPlayer:GetTeam())) then
				iBestKnownTechScore = math.max( iBestKnownTechScore, pPlayer:GetTechScore() );
			end
		end
	end

	iBestKnownTechScore = math.max( iBestKnownTechScore, iOurTechScore );

	return ((100*iOurTechScore)/math.max(iBestKnownTechScore, 1));
end

function numberOfTechsBehindLeadTeam(pTeam)

	local pBestTeam = Teams[0];
	local iBestTeamTechCount = 0;
	for iTeamLoop = 0, GameDefines.MAX_CIV_TEAMS-1, 1 do
		local pOtherTeam = Teams[iTeamLoop];
		local pOtherTeamTechs = pOtherTeam:GetTeamTechs();
		if(pOtherTeam ~= nil) and pOtherTeam:GetID() ~= pTeam:GetID() then
			local iTechCount = 0;
			for eTech in GameInfo.Technologies() do
				if pOtherTeam:IsHasTech(eTech.ID) then
					iTechCount = iTechCount + 1;
				end
			end	
			if (iTechCount > iBestTeamTechCount) then
				pBestTeam = pOtherTeam;
				iBestTeamTechCount = iTechCount;
			end
		end
	end

	local iTechCount = 0;
	for eTech in GameInfo.Technologies() do
		if pTeam:IsHasTech(eTech.ID) then
			iTechCount = iTechCount + 1;
		end
	end	

	return iBestTeamTechCount - iTechCount;
end

if TechDiffusion_Enabled == true then
	Events.ActivePlayerTurnEnd.Add(TechDiffusion);
end