-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

-- Insert resources entry into InfoCornerID table
-- Added by Argentum Studios 2010/09/28
local maxIdx = 0;
if( InfoCornerID["Resources"] == nil ) then
    for index, value in pairs(InfoCornerID) do
        maxIdx = maxIdx + 1;
    end
    InfoCornerID["Resources"] = maxIdx;
else
    maxIdx = InfoCornerID.Resources;
end
-- End add

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
m_InfoData = {};
m_InfoData[ InfoCornerID.None ] = {
    ToolTip="TXT_KEY_CLOSE",
    Image="assets/UI/Art/Icons/MainOpen.dds",
    HL="assets/UI/Art/Icons/MainOpenHL.dds" };
    
m_InfoData[ InfoCornerID.Tech ] = {
    ToolTip="TXT_KEY_IC_RESEARCH",
    Image="assets/UI/Art/Icons/MainTechButton.dds",
    HL="assets/UI/Art/Icons/MainTechButtonHL.dds" };
    
m_InfoData[ InfoCornerID.Units ] = {
    ToolTip="TXT_KEY_IC_UNIT",
    Image="assets/UI/Art/Icons/MainUnitButton.dds",
    HL="assets/UI/Art/Icons/MainUnitButtonHL.dds" };
    
m_InfoData[ InfoCornerID.Cities ] = {
    ToolTip="TXT_KEY_IC_CITY",
    Image="assets/UI/Art/Icons/MainCityButton.dds",
    HL="assets/UI/Art/Icons/MainCityButtonHL.dds" };

-- Added by Argentum Studios 2010/09/28
m_InfoData[ InfoCornerID.Resources ] = {
    ToolTip="TXT_KEY_AGS_IC_RESOURCE",
	Image="assets/UI/Art/Icons/AgSMainResourceButton.dds",
	HL="assets/UI/Art/Icons/AgSMainResourceButtonHL.dds" };
-- End add

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function OnInfoButton( iInfoType )
    Events.OpenInfoCorner( iInfoType );
end
Controls.LeftPull:RegisterSelectionCallback( OnInfoButton );


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function OnOpenInfoCorner( iInfoType )
    if( iInfoType ~= InfoCornerID.Diplo ) then 
        Controls.PDButton:SetTexture( m_InfoData[iInfoType].Image );
        Controls.PDImage:SetTexture( m_InfoData[iInfoType].Image );
        Controls.PDAlpha:SetTexture( m_InfoData[iInfoType].HL );
    end
end
Events.OpenInfoCorner.Add( OnOpenInfoCorner );


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
local controlTable;

-- Loop over all entries in m_InfoData rather than stopping when the 0 index is hit
-- Replaced by Argentum Studios 2010/09/28
for i = 0, maxIdx do
    local value = m_InfoData[i];

	if( value ~= nil ) then
-- Original code
-- for i = 0, #m_InfoData do
-- End replace
        controlTable = {};
        Controls.LeftPull:BuildEntry( "InstanceOne", controlTable );

        controlTable.Button:LocalizeAndSetToolTip( value.ToolTip );
    
        if( i == InfoCornerID.None ) then
            controlTable.Button:SetTexture(  "assets/UI/Art/Icons/MainClose.dds" );
            controlTable.MOImage:SetTexture( "assets/UI/Art/Icons/MainClose.dds" );
            controlTable.MOAlpha:SetTexture( "assets/UI/Art/Icons/MainCloseHL.dds" );
        else
            controlTable.Button:SetTexture( value.Image );
            controlTable.MOImage:SetTexture( value.Image );
            controlTable.MOAlpha:SetTexture( value.HL );
        end
        controlTable.Button:SetVoid1( i );
	end
end
Controls.LeftPull:CalculateInternals();

