--[[
open source, although a link back would be appreciated if you feel stuff here helped you out
http://forums.civfanatics.com/showthread.php?t=396471
thanks
]]--

local WORKER = 1;
local FREEBIEUNITS = 4;
local FREEGOLD = 100;

local MASONRY = 10;
local CHIVALRY = 25;
local TELEGRAPH = 50;

local MUGHALFORT = 2;
local CITYWALLS = 37;
local CASTLE = 38;
local MILITARYBASE = 39;

local gameinit = 0;
local verbose = 0;

function vp ( str )
	if ( verbose < 1 ) then return; end
	print("");
	print( str );
end

function liberationboostcatch ( hex, civ, cityid)

	local player = Players[ civ ];

	if ( player:GetNumCities() > 1 ) then return; end

	local city = player:GetCityByID(cityid);
	local prevowner = city:GetPreviousOwner();

	if ( prevowner < 0 ) then return; end

	if ( prevowner >= 0 and city:GetOriginalOwner() == civ and player:GetNumCities() == 1 and player:GetNumUnits() == 0 ) then
		local liberator = Players[ prevowner ];
		vp( civ .. " liberated by " .. prevowner .. " at city " .. city:GetName() );
		liberationboostdobonus(hex, civ, prevowner, cityid);
	end

end
Events.SerialEventCityCreated.Add ( liberationboostcatch );

function liberationboostdobonus (hex, freed, lib, cityid)

	local player = Players[ freed ];
	local liberator = Players[ lib ];

	local hx, hy = ToGridFromHex( hex.x, hex.y );
	local plot = Map.GetPlot(hx, hy);

	local city = player:GetCityByID(cityid);

	local playerteam = Teams[player:GetTeam()];
	local playerteamtech = playerteam:GetTeamTechs();
	local libteam = Teams[liberator:GetTeam()];
	local libteamtech = libteam:GetTeamTechs();

	local canwall = 0;
	local cancastle = 0;
	local canbase = 0;

	local count = 0;
	local techinfo = GameInfo.Technologies[count];

	while( techinfo ~= nil ) do

		if ( libteamtech:HasTech( count ) ) then

			playerteamtech:SetHasTech(count, true);

			if ( count == MASONRY ) then canwall = 1;
			elseif ( count == CHIVALRY ) then cancastle = 1;
			elseif ( count == TELEGRAPH ) then canbase = 1;
			end

		end
		count = count + 1;
		techinfo = GameInfo.Technologies[count];
	end

	player:ChangeGold(FREEGOLD);
	player:InitUnit(WORKER, plot:GetX(), plot:GetY());

	for i = 1, FREEBIEUNITS do 
		player:InitUnit(city:GetConscriptUnit(), plot:GetX(), plot:GetY());
	end

	if ( canwall == 1 ) then
		if (city:GetNumRealBuilding(CITYWALLS) == 0) then 
			city:SetNumRealBuilding(CITYWALLS, 1);
		end
	end

	if ( cancastle == 1 ) then
		local typestring = GameInfo.Civilizations[ player:GetCivilizationType() ].Type;
		if ( typestring ~= nil and string.find( typestring, 'CIVILIZATION_INDIA') ) then
			if (city:GetNumRealBuilding(MUGHALFORT) == 0) then 
				city:SetNumRealBuilding(MUGHALFORT, 1); 
			end
		else
			if (city:GetNumRealBuilding(CASTLE) == 0) then 
				city:SetNumRealBuilding(CASTLE, 1); 
			end
		end
	end
	if ( canbase == 1 ) then
		if (city:GetNumRealBuilding(MILITARYBASE) == 0) then 
			city:SetNumRealBuilding(MILITARYBASE, 1);
		end
	end

	if ( not player:IsMinorCiv() ) then
		for num = 0, GameDefines.MAX_CIV_PLAYERS-1, 1 do
			if ( lib ~= num ) then
				local tmpplayer = Players[ num ];
				local tmpteam = tmpplayer:GetTeam();

				if ( libteam:IsAtWar(tmpteam) ) then
					playerteam:DeclareWar(tmpteam, true);
				end
			end
		end
	end

	-- too bad about these kind of commands and no set defensive pact :(
	--Game.DoFromUIDiploEvent( FromUIDiploEventTypes.FROM_UI_DIPLO_EVENT_WORK_AGAINST_SOMEONE_RESPONSE, arg2, 0, arg1 );
	--Game.DoFromUIDiploEvent( FromUIDiploEventTypes.FROM_UI_DIPLO_EVENT_WORK_WITH_US_RESPONSE, arg2, 1, 0 );
	--Game.DoFromUIDiploEvent( FromUIDiploEventTypes.FROM_UI_DIPLO_EVENT_HUMAN_DECLARES_WAR, arg1, arg2, 0 );

end
